      SUBROUTINE CYLSPR(Z,NPXRD,NPYRD,PLANE,RSTEP,X1,XL)
      DIMENSION Z(NPXRD,NPYRD)
C
  200 FORMAT(1X,/,' THE INPUT DATA IS ASSUMED TO BE IN',
     & ' CYLINDRICAL GEOMETRY. ',/,
     & ' IT WILL BE TRANSFORMED TO PLANE GEOMETRY USING A',/,
     & ' RANGE STEP INCREMENT OF ',F10.2,' m')
  300 FORMAT(1X,/,' THE INPUT DATA IS ASSUMED TO BE IN',
     & ' PLANE GEOMETRY ',/,
     & ' IT WILL BE TRANSFORMED TO CYLINDRICAL GEOMETRY USING A',/,
     & ' RANGE STEP INCREMENT OF ',F10.2,' m')
  400 FORMAT(1X,' RANGE STEP INCREMENT NOT PROPERLY SPECIFIED ',/,
     & ' REVISE 6TH VALUE IN INPUT DATA FILE ',/,
     & ' EXECUTION IS TERMINATED ')
  500 FORMAT(1X,'  ***   WARNING :    ****  ',/,
     & '  INITIAL RANGE FOR INPUT DATA IS 0.0 m. ',/,
     & '  CORRECTION FROM PLANE TO CYLINDRICAL GEOMETRY OR VICEVERSA',/,
     & '  WILL BE PERFORMED ASSUMING AN INITIAL RANGE OF',
     & '  1.0E-5 METERS ',/)   
C
      IF(RSTEP.LE.0.0) THEN
       WRITE(6,400)
       STOP
      END IF
C
      IF(PLANE.EQ.0.0)   THEN
      FAC=-10.0
      WRITE(6,200) RSTEP
      ELSE
      FAC=10.0
      WRITE(6,300) RSTEP
      END IF
C
      IF(X1.LT.XL)   THEN
       STEP=RSTEP
       X=X1
      ELSE
       STEP=-RSTEP
       X=XL
      END IF
      ISTART=1
      IF(X.LE.0.0)   THEN
      WRITE(6,500)
      CORR= -5.0*FAC
      DO 2200  J=1,NPYRD
      Z(1,J)= Z(1,J) + CORR
 2200 CONTINUE
      ISTART=2
      END IF
C
      DO   2400   I=ISTART,NPXRD
      CORR= FAC * ALOG10(X+(I-1)*RSTEP)
      DO   2400   J=1,NPYRD
      Z(I,J)= Z(I,J) + CORR
 2400 CONTINUE
      RETURN
      END
