C
C     ***GENERAL CONTROL DATA FOR MINDIS
C     *** JOHN STEIERT   2-DEC-81
C
C          LINTYP        LINE TYPE: 0=SOLID,1=DOT,2=DASH,3=CHAIN DOT
C                                   4=CHAIN DASH
C          PLTTYP        PLOT TYPE: 0=CARTESIAN, 1=POLAR
C          CURSYM        CURRENT SYMBOL FOR PLOTTING VALUES
C          NXTSYM        NEXT SYMBOL TO BE USED FOR PLOTTING
C          PLTNO         PLOT IDENTIFICATION NUMBER
C          PLTLVL        CURRENT PLOT LEVEL (0<=LEVEL<=4)
C          CHECK         SHOWS IF MESSAGE TO BE GIVEN FOR OUT OF BOUND
C          UPRGHT        SHOWS IF PLOT IS UPRIGHT
C          LBGNPL        SHOWS IF BGNPL ROUTINE HAS BEEN CALLED
C          LWNDOW        SHOWS IF WINDOWING IS OPERATION
C          XTIKS         X-AXIS TICK INDIC: 0=NO AXIS,1=BELOW AXIS,2=ABOVE AXIS
C          YTIKS         Y-AXIS TICK INDIC: 0=NO AXIS,1=BELOW AXIS,2=ABOVE AXIS
C          BLSCLF        BASIC SCALING FACTOR FOR ALL POINTS
C          LTTCRT        SHOWS IF A CRT TYPE DEVICE IS IN USE
C          XLBANG        ANGLE AT WHICH X LABELS TO BE DRAWN
C          YLBANG        ANGLE AT WHICH Y LABELS TO BE DRAWN
C          XADTKS        NUMBER OF ADDITIONAL X TICKS PER STEP
C          YADTKS        NUMBER OF ADDITIONAL Y TICKS PER STEP
C          LSYMSP        SHOWS IF A SPECIFIC SYMBOL REQUESTED
C          LINTX         TRUE WHEN X-AXIS VALUES TO BE INTEGER
C          LINTY         TRUE WHEN Y-AXIS VALUES TO BE INTEGER
C          SECRTY        SECURITY CODE: 0=UNCL,1=CONF,2=SECRET,3=COSMIC
C          INTERP        INTERPOLATION METHOD: 0=STRAIGHT LINE
C                                              1=CUBIC SPLINE
C          RPI           VALUE FOR PI
C          LBATCH        SHOWS WHEN BATCH RUN
C          TTYPE         Terminal type (4025,4027,4112, 240 or 0)
C          SCLUNI        Scaling factor: 1.0=inches, 0.3937=metric
C          LAXIS         Shows whether or not axis drawing is required.
C          DEFHCD        Default hardcopy device (XX=Not specified)
C          LBRDR         True if Page border to be drawn
C
      INTEGER LINTYP, PLTTYP, CURSYM, NXTSYM, PLTNO, PLTLVL
      INTEGER XTIKS, YTIKS, XADTKS, YADTKS
      REAL BLSCLF, XLBANG, YLBANG
      LOGICAL CHECK, UPRGHT, LBGNPL, LWNDOW, LTTCRT
      LOGICAL LSYMSP, LINTX,  LINTY
      INTEGER SECRTY, INTERP
      REAL RPI
      LOGICAL LBATCH
      INTEGER TTYPE
      REAL SCLUNI
      LOGICAL LAXIS, LBRDR
      CHARACTER*5 DEFHCD
      COMMON /CTL$DT/ LINTYP, PLTTYP, CURSYM, NXTSYM, PLTNO,
     $                PLTLVL, CHECK,  UPRGHT, LBGNPL, LWNDOW,
     $                XTIKS,  YTIKS,  BLSCLF, LTTCRT,
     $                XLBANG, YLBANG, XADTKS, YADTKS, LSYMSP,
     $                LINTX,  LINTY,  SECRTY, INTERP, RPI,
     $                LBATCH, TTYPE,  SCLUNI, LAXIS,  DEFHCD,
     $                LBRDR
