      SUBROUTINE CGXSMB (X,Y,HEIGHT,CHTEXT,THETA,N)
C     ------------------------------------------------------------------
C
C     *** JS   13-FEB-84      Integrate into DISPLA.
C     *** JS   20-FEB-84      Modify for DISPLA use.
C
C     FORTRAN IV IBM S/370 VERSION - 1980-06-04- ARNE LUND, NEUCC
C     ORIGINAL VERSION BY - N.WOLCOTT, NBS, 301-921-3384
C
C     ------------------------------------------------------------------
C
C     SIMILAR TO ROUTINE SYMBOL USED WITH PEN PLOTTERS
C     INSTRUCTIONS FOR DRAWING CHARACTERS ARE IN ALFBET STORED
C     TWO INSTRUCTIONS PER WORD. A ZERO FOR PEN POSITION INDICATES
C     END OF A CHARACTER. INPUT TEXTUAL STRINGS MUST BE COMPOSED OF ONLY
C     THE FORTRAN CHARACTERS A-Z 0-9+-/=()*,.X  AND THE NON-FORTRAN
C     SPECIAL CHARACTERS WHICH ARE DESCRIBED BELOW.
C        X,Y   =  (X,Y) COORDINATE OF LOWER LEFT HAND CORNER OF TEXT
C        HEIGHT =  HEIGHTH (IN INCHES) OF UPPER CASE CHARACTERS
C        TEXT   =  INPUT TEXTUAL ARRAY OR HOLLERITH STRING
C        THETA  =  ANGLE IN DEGREES OF TEXT FROM X-AXIS
C        N      =  NUMBER OF CHARACTERS IN TEXT STRING
C
C     IF N IS NEGATIVE AND TEXT IS A BINARY INTEGER BETWEEN
C     1 AND 21 A CENTERED SYMBOL FROM THE SYMBOL SET IS PRODUCED
C     AT (X,Y).
C     IF N IS 0 A SINGLE SIMPLEX ALPHANUMERIC FORTRAN CHARACTER
C     (RIGHT JUSTIFIED IN TEXT) IS PRODUCED AT (X,Y).
C     IF X AND/OR Y EQUAL 999. THE ANNOTATION WILL BE CONTINUED
C     AFTER THE PREVIOUS X AND/OR Y TERMINATION
C
C     ISTART(I) CONTAINS THE INDEX INTO ALFBET OF THE FIRST INSTRUCTION
C     OF CHARCTER NUMBER I WHOSE WIDTH IS STORED IN WIDTH(I)
C     CHARACTERS 1 TO 26 ARE ROMAN SIMPLEX UPPER CASE
C     CHARACTERS 27 TO 50 ARE GREEK SIMPLEX UPPER CASE
C     CHARACTERS 51 TO 76 ARE ROMAN SIMPLEX LOWER CASE
C     CHARACTERS 77 TO 100 ARE GREEK SIMPLEX LOWER CASE
C     CHARACTERS 101 TO 126 ARE ROMAN COMPLEX UPPER CASE
C     CHARACTERS 127 TO 150 ARE GREEK COMPLEX UPPER CASE
C     CHARACTERS 151 TO 176 ARE ROMAN COMPLEX LOWER CASE
C     CHARACTERS 177 TO 200 ARE GREEK COMPLEX LOWER CASE
C     CHARACTERS 201 TO 226 ARE ITALIC UPPER CASE
C     CHARACTERS 227 TO 250 ARE MATHEMATICAL AND SPECIAL SYMBOLS
C     CHARACTERS 251 TO 276 ARE ITALIC LOWER CASE
C     CHARACTERS 277 TO 300 ARE MATHEMATICAL AND SPECIAL SYMBOLS
C     CHARACTERS 301 TO 320 ARE SIMPLEX DIGITS AND SPECIAL SYMBOLS
C     CHARACTERS 321 TO 340 ARE COMPLEX DIGITS AND SPECIAL SYMBOLS
C     CHARACTERS 341 TO 360 ARE ITALIC DIGITS AND SPECIAL SYMBOLS
C     CHARACTERS 361 TO 380 ARE DUPLEX DIGITS AND SPECIAL SYMBOLS
C     CHARACTERS 381 TO 432 ARE DUPLEX UPPER AND LOWER CASE
C     ISPEC(13) ARE THIRTEEN SPECIAL CHARACTERS CHOSEN FROM THE NON-
C     FORTRAN SET AT JOUR SITE. CURRENT IMPLEMENTATIONS FOLLOW
C     SP11 MAY BE SET TO THE COMPUTER STOP CODE IF ONE EXISTS.
C     SP1   CHAR(14)      TURN ON CHARACTER SUBSCRIPT
C     SP2   CHAR(15)      TURN ON CHARACTER SUPERSCRIPT
C     SP3   CHAR(16)      TURN ON UPPER CASE
C     SP4   CHAR(17)      TURN ON LOWER CASE
C     SP5   CHAR(18)      TURN ON COMPLEX LETTERS
C     SP6   CHAR(19)      TURN ON CHARACTER GREEK LETTER OR MATH SYMBOL
C     SP7   CHAR(20)      TURN ON SIMPLEX LETTERS
C     SP8   CHAR(21)      BACK SPACE LAST CHARACTER
C     SP9   CHAR(22)      ITALIC LETTERS
C     SP10  CHAR(23)      DUPLEX LETTERS
C     SP11  CHAR(24)      TERMINATE SCAN
C     SP12  CHAR(25)      END SUBSCRIPT OR SUPERSCRIPT
C     SP13  CHAR(26)      END GREEK
C
C     ------------------------------------------------------------------
C
      DIMENSION IFORT(47),IA(256),IB(60),ISPEC(13)
      DIMENSION ALFBET(4711),WIDTH(432),ISTART(432),ISYMBO(128)
      DIMENSION JSTSYM(22)
      DIMENSION OLDX(6),OLDY(6)
      COMMON /G99ALF/ WIDTH,ALFBET,ISTART,ISYMBO,JSTSYM
c      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT,
c     2                FIRST,LNGTH
      LOGICAL FIRST,LNGTH
      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT
      COMMON /G99LOG/ FIRST,LNGTH
C*    INTEGER STRIN,CHAR,TEXT,ALFBET,ISTART
      INTEGER ALFBET,ISTART
      EQUIVALENCE (IB(1),IFORT(1)), (IB(48),ISPEC(1))
C/    INTEGER CHXCVT
      CHARACTER CHTEXT(N)
C     RX=CX-SY
C     RY=SX+CY
C     RX(X,Y)=RY(-Y,X)
C     RY(X,Y)=RX(Y,-X)
C     IFLD GETS N BITS STARTING AT NSTART TH BIT FROM RIGHT
      IFLD(NSTART,NBITS,IWORD)=MOD(IWORD/(2**(NSTART-NBITS)),2**NBITS)+(
C    2(1-ISIGN(1,+IWORD))/2)*(2**NBITS-1)
C     ***USE ABOVE CARD IF YOUR MACHINE HAS ONES COMPLEMENT ARITHMETIC
     2  (1-ISIGN(1,IWORD))/2)*(2**NBITS-MIN0(1,
     XMOD(-IWORD,2**(NSTART-NBITS))))
C     ***USE ABOVE CARD IF YOUR MACHINE HAS TWOS COMPLEMENT ARITHMETIC
C     ICHAR(J) GETS THE J TH CHARACTER OF NCHAR BITS FROM A STRING
C     COMPOSED OF WORDS NWORD BITS LONG.
C*    ICHAR(J)=IFLD((NWORD-MOD((J-1),NCWD)*NCHAR),NCHAR,STRIN((J+NCWD-1)/
C*   2NCWD,TEXT))
C/      ICHAR(J) = IFLD( NWORD - MOD(J-1,NCWD) * NCHAR, NCHAR,
C/     2                CGXG99((J+NCWD-1)/NCWD,TEXT) )
      R(XX,YY)=CO*XX-SI*YY
C
C     ***Start of actual code.
5     IF (FIRST) THEN
           NCWD=NWORD/NCHAR
           ICHSTA=-1
           IF (IFLD(NWORD,NCHAR,IFORT(1)).EQ.65) ICHSTA=NWORD
           IF (IFLD(NCHAR,NCHAR,IFORT(1)).EQ.65) ICHSTA=NCHAR
           IF (ICHSTA.EQ.-1) STOP 'HERSHEY SYSTEM ERROR 1'
           DO 178 I=1,13
C/                ISPEC(I)=CHXCVT(CHAR(ISPEC(I)))
                IA(ISPEC(I)+1)=47+I
 178            CONTINUE
           DO 10 I=1,60
                LL=IFLD(ICHSTA,NCHAR,IB(I))
                IA(LL+1)=I
10              CONTINUE
           FIRST=.FALSE.
           ENDIF
      THE=THETA*355./(180.*113.)
      SI=SIN(THE)
      CO=COS(THE)
      SCALE=HEIGHT/21.
      RSCALE=SCALE
C     ***OFFSET OF 11 UNITS
      X1=X
      Y1=Y
      IF (X1.GT.998.5) X1=OLDX(6)
      IF (Y1.GT.998.5) Y1=OLDY(6)
      NN=N
      IF (NN) 50,30,120
C
C     *** N is 0 - Single SIMPLEX alphanumeric character.
30    ICHR=NCWD-1
      IG=ICHAR(CHTEXT(ICHR+1))
      IC=IA(IG+1)
      IF (IC.LE.47) GO TO 40
C     WRITE(IOUT,40) IG
      GO TO 440
40    NN=1
      GO TO 140
C
C     *** N is negative - symbol case
50    IF (N.EQ.-1) GO TO 60
      CALL CGXPLT (X1,Y1,2)
60    IG=ICHAR(CHTEXT(1))+1
      IF (IG.LE.22) GO TO 70
C     WRITE(IOUT,41) IG
      GO TO 440
70    I6=JSTSYM(IG)
      I5=30
C
C     ***Loop outputting symbol
 80   CONTINUE
           I8=IFLD(I5,3,ISYMBO(I6))
C          *** GO TO CENTER OF SYMBOL
           IF (I8) 100,90,100
 90             CALL CGXPLT (X1,Y1,3)
                X1=X1+20.
                Y1=Y1+20.
                GO TO 440
C
 100       IX=IFLD(I5-3,6,ISYMBO(I6))
           IY=IFLD(I5-9,6,ISYMBO(I6))
           XI=SCALE*(FLOAT(IX-32))
           YI=SCALE*(FLOAT(IY-32))
           CALL CGXPLT (X1+R(XI,YI),Y1+R(YI,-XI),I8)
           I5=45-I5
           IF (I5.EQ.30) I6=I6+1
           GO TO 80
C
C     *** N is positive - normal character output
 120  DO 130 I=1,6
           OLDX(I)=X
           OLDY(I)=Y
 130       CONTINUE
      ICHR=0
C
C     ***Character
 140  IC=0
C
C     ***Simplex capital letters
      IP=0
      ICAP=0
      ICOMP=0
      ITALIC=0
      IDUPLE=0
C
C     ***Not Greek letters
      IGREEK=0
C
C     ***Print symbol on line (not subscript or superscript)
      L=1
      SCALE=HEIGHT/21.
      DO 430 I1=1,NN
C
C          ***Extract character from text.
           ICHR=ICHR+1
           IG=ICHAR(CHTEXT(ICHR))
           IC=IA(IG+1)
           IF (ICHR.GT.NN.AND.N.GT.0) GO TO 450
           IF (IC.GT.60) THEN
                WRITE (IOUT,150) IG
 150                FORMAT (1X,19HILLEGAL INPUT CHAR ,I12)
                GO TO 430
                ENDIF
           IP=ICOMP+ICAP+ITALIC+IDUPLE
           IF (IC-27) 170,410,270
C
C               ***Number of symbol
 170            CONTINUE
                IC=IC+IP+IGREEK-ICAP*IDUPLE*24/(50*380)
 180            I6=ISTART(IC)
                I5=30
                IF (LNGTH) GO TO 250
C               ***Print alphabetic character
 190            I8=IFLD(I5,3,ALFBET(I6))
C
C               *** Test for end of character, I8=0
                IF (I8.EQ.0) GO TO 240
                IX=IFLD(I5-3,6,ALFBET(I6))
                IY=IFLD(I5-9,6,ALFBET(I6))
C
C               *** If L=1:   Print symbol on line.
C               ***    L=2:   Subscript.
C               ***    L=3:   Superscript.
                GO TO (200,210,220), L
C
C                    *** Print symbol on line.
 200                 RSCALE=SCALE
                     YOFF=0.
                     GO TO 230
C
C                    ***Subscript
210                  RSCALE=SCALE*0.5
                     YOFF=-HEIGHT/4.
                     GO TO 230
C
C                    *** Superscript
 220                 RSCALE=SCALE*0.5
                     YOFF=HEIGHT*3./4.
C               ABOVE FACTORS NEEDED TO CORRECT FOR DIFFERENT SIZE LETTERS
 230            YI=FLOAT(IY-11)*RSCALE+YOFF
                XI=FLOAT(IX-10)*RSCALE
                CALL CGXPLT (X1+R(XI,YI),Y1+R(YI,-XI),I8)
                I5=45-I5
                IF (I5.EQ.30) I6=I6+1
                GO TO 190
C
C 240       IGREEK=0
 240  CONTINUE
C*NEUCC    *** DEFINE SCALE WHEN USING CGXSML (LNGTH = .TRUE.)
250        CONTINUE
           RSCALE = SCALE
           IF (L .GT. 1) RSCALE = .5 * SCALE
           X1=X1+R(WIDTH(IC)*RSCALE,0.0)
           Y1=Y1+R(0.,-WIDTH(IC)*RSCALE)
           DO 260 I=1,5
                OLDX(I)=OLDX(I+1)
                OLDY(I)=OLDY(I+1)
 260            CONTINUE
           OLDX(6)=X1
           OLDY(6)=Y1
           RSCALE=SCALE
C          L=1
           GO TO 430
C
 270       IF (IC.GT.47) GO TO 280
           IC=IC+273
           IF (ICOMP.NE.0) IC=IC+20
           IF (ITALIC.NE.0) IC=IC+40
           IF (IDUPLE.NE.0) IC=IC+60
           GO TO 180
C
280        L1=IC-47
C
C          *** Switch on new char type
           GOTO (290,300,310,320,330,340,350,360,380,390,400,405,407),L1
C
C               ***Subscript
290             L=2
                GO TO 430
C
C               *** Superscript
300             L=3
                GO TO 430
C
C               *** Upper case
310             ICAP=0
                GO TO 430
C
C               *** Lower case
320             ICAP=50
                GO TO 430
C
C               *** Complex letters
330             ICOMP=100
                ITALIC=0
                IDUPLE=0
                GO TO 430
C
C               *** Greek letters
340             IGREEK=26
                IF (IDUPLE.NE.0) IGREEK=0
                GO TO 430
C
C               *** Simplex letters
350             ICOMP=0
                ITALIC=0
                IDUPLE=0
                GO TO 430
C
C               *** Backspace
360             DO 370 I=1,5
                     IK=6-I
                     OLDX(IK+1)=OLDX(IK)
370                  OLDY(IK+1)=OLDY(IK)
                X1=OLDX(6)
                Y1=OLDY(6)
                GO TO 430
C
C               *** Italic
380             ITALIC=200
                ICOMP=0
                IDUPLE=0
                GO TO 430
C
C               *** Duplex
390             IDUPLE=380
                ICOMP=0
                ITALIC=0
                GO TO 430
C
C               *** End of Scan
400             GO TO 450
C
C               *** End subscript or superscript
 405            CONTINUE
                L=1
                GOTO 430
C
C               *** End of Greek or Special character
 407            CONTINUE
                IGREEK=0
                GOTO 430
C
C               Blank Space
 410            X1=X1+R(20.*RSCALE,0.)
                Y1=Y1+R(0.,-20.*RSCALE)
                DO 420 I=1,5
                     OLDX(I)=OLDX(I+1)
420                  OLDY(I)=OLDY(I+1)
                OLDX(6)=X1
                OLDY(6)=Y1
CXX             L=1
 430       CONTINUE
C
 440  CONTINUE
      IF(LNGTH) GO TO 450
      OLDX(6)=X1
      OLDY(6)=Y1
 450  IF (LNGTH) XL=SQRT((X1-X)**2+(Y1-Y)**2)
      RETURN
      END
C
C ****************************************************************
C
      FUNCTION   CGXSML (HEIGHT,CHTEXT,N)
C
C*     LENGTH OF TEXT IS RETURNED AS RESULT
C
      DIMENSION IA(256),IB(60),OLDX(6),OLDY(6)
c      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT,
c     2                FIRST,LNGTH
      LOGICAL LNGTH,FIRST
      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT
      COMMON /G99LOG/ FIRST,LNGTH
      CHARACTER*(*) CHTEXT
C
      LNGTH=.TRUE.
      CALL CGXSMB (0.,0.,HEIGHT,CHTEXT,0.,N)
      CGXSML = XL
      LNGTH=.FALSE.
      RETURN
      END
C
C ****************************************************************
C
C/    INTEGER FUNCTION CGXG99 (I, CHTEXT)
C/    CHARACTER*(*) CHTEXT
CC/
C/    CGXG99 = CHTEXT(I:I)
C/    RETURN
C/    END
C
C ****************************************************************
C
c      SUBROUTINE BLCKX5
      block data BLCKX5
C
      DIMENSION ISY110(60),ISY111(60),ISY112(8),JSTSYM(22),ISYMBO(128)
      DIMENSION IAL110(60),IAL111(60),IAL112(60),IAL113(60),IAL114(60),
     2 IAL115(60),IAL116(60),IAL117(60),IAL118(60),IAL119(60),IAL120(60)
     3,IAL121(60),IAL122(60),IAL123(60),IAL124(60),IAL125(60),IAL126(60)
     4,IAL127(60),IAL128(60)
      DIMENSION IAL129(60),IAL130(60),IAL131(60),IAL132(60),IAL133(60),
     2 IAL134(60),IAL135(60),IAL136(60),IAL137(60),IAL138(60),IAL139(60)
     3,IAL140(60),IAL141(60),IAL142(60),IAL143(60),IAL144(60),IAL145(60)
     4,IAL146(60),IAL147(60)
      DIMENSION IAL148(60),IAL149(60),IAL150(60),IAL151(60),IAL152(60),
     2 IAL153(60),IAL154(60),IAL155(60),IAL156(60),IAL157(60),IAL158(60)
     3,IAL159(60),IAL160(60),IAL161(60),IAL162(60),IAL163(60),IAL164(60)
     4,IAL165(60),IAL166(60)
      DIMENSION IAL167(60),IAL168(60),IAL169(60),IAL170(60),IAL171(60),
     2 IAL172(60),IAL173(60),IAL174(60),IAL175(60),IAL176(60),IAL177(60)
     3,IAL178(60),IAL179(60),IAL180(60),IAL181(60),IAL182(60),IAL183(60)
     4,IAL184(60),IAL185(60)
      DIMENSION IAL186(60),IAL187(60),IAL188(31),WID110(100),WID111(100)
     2,WID112(100),WID113(100),WID114(32),IST110(100),IST111(100),
     3 IST112(100),IST113(100),IST114(32)
      DIMENSION IFORT(47),IA(256),IB(60),ISPEC(13),OLDX(6),OLDY(6)
      DIMENSION IALFBE(4711),WIDTH(432),ISTART(432)
C
      COMMON /G99ALF/ WIDTH,IALFBE,ISTART,ISYMBO,JSTSYM
c      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT,
c     2                FIRST,LNGTH
C
      LOGICAL FIRST,LNGTH
      COMMON /G99SAV/ XL,OLDX,OLDY,IA,IB,NWORD,NCHAR,NCWD,IOUT
      COMMON /G99LOG/ FIRST,LNGTH
C
      EQUIVALENCE (IB(1),IFORT(1)), (IB(48),ISPEC(1))
      EQUIVALENCE (IALFBE(1),IAL110), (IALFBE(61),IAL111), (IALFBE(121),
     2 IAL112), (IALFBE(181),IAL113), (IALFBE(241),IAL114), (IALFBE(301)
     3,IAL115), (IALFBE(361),IAL116), (IALFBE(421),IAL117), (IALFBE(481)
     4,IAL118), (IALFBE(541),IAL119), (IALFBE(601),IAL120), (IALFBE(661)
     5,IAL121), (IALFBE(721),IAL122), (IALFBE(781),IAL123), (IALFBE(841)
     6,IAL124), (IALFBE(901),IAL125), (IALFBE(961),IAL126),
     7 (IALFBE(1021),IAL127), (IALFBE(1081),IAL128)
      EQUIVALENCE (IALFBE(1141),IAL129), (IALFBE(1201),IAL130),
     2 (IALFBE(1261),IAL131), (IALFBE(1321),IAL132), (IALFBE(1381),
     3 IAL133), (IALFBE(1441),IAL134), (IALFBE(1501),IAL135),
     4 (IALFBE(1561),IAL136), (IALFBE(1621), IAL137), (IALFBE(1681),
     5 IAL138), (IALFBE(1741),IAL139), (IALFBE(1801),IAL140),
     6 (IALFBE(1861),IAL141), (IALFBE(1921),IAL142), (IALFBE(1981),
     7 IAL143), (IALFBE(2041),IAL144), (IALFBE(2101),IAL145),
     8 (IALFBE(2161),IAL146), (IALFBE(2221),IAL147)
      EQUIVALENCE (IALFBE(2281),IAL148), (IALFBE(2341),IAL149),
     2 (IALFBE(2401),IAL150), (IALFBE(2461),IAL151), (IALFBE(2521),
     3 IAL152), (IALFBE(2581),IAL153), (IALFBE(2641),IAL154),
     4 (IALFBE(2701),IAL155), (IALFBE(2761),IAL156), (IALFBE(2821),
     5 IAL157), (IALFBE(2881),IAL158), (IALFBE(2941),IAL159),
     6 (IALFBE(3001),IAL160), (IALFBE(3061),IAL161), (IALFBE(3121),
     7 IAL162), (IALFBE(3181),IAL163), (IALFBE(3241),IAL164),
     8 (IALFBE(3301),IAL165), (IALFBE(3361),IAL166)
      EQUIVALENCE (IALFBE(3421),IAL167), (IALFBE(3481),IAL168),
     2 (IALFBE(3541),IAL169), (IALFBE(3601),IAL170), (IALFBE(3661),
     3 IAL171), (IALFBE(3721),IAL172), (IALFBE(3781),IAL173),
     4 (IALFBE(3841),IAL174), (IALFBE(3901),IAL175), (IALFBE(3961),
     5 IAL176), (IALFBE(4021),IAL177), (IALFBE(4081),IAL178),
     6 (IALFBE(4141),IAL179), (IALFBE(4201),IAL180), (IALFBE(4261),
     7 IAL181),(IALFBE(4321),IAL182), (IALFBE(4381),IAL183),
     8 (IALFBE(4441),IAL184), (IALFBE(4501),IAL185)
      EQUIVALENCE (IALFBE(4561),IAL186), (IALFBE(4621),IAL187),
     2 (IALFBE(4681),IAL188)
      EQUIVALENCE (WIDTH(1),WID110), (WIDTH(101),WID111), (WIDTH(201),
     2 WID112), (WIDTH(301),WID113), (WIDTH(401),WID114)
      EQUIVALENCE (ISTART(1),IST110), (ISTART(101),IST111), (ISTART(201)
     2,IST112), (ISTART(301),IST113), (ISTART(401),IST114)
      EQUIVALENCE (ISYMBO(1),ISY110), (ISYMBO(61),ISY111), (ISYMBO(121),
     2 ISY112)
C
      DATA IA /256*511/
      DATA IFORT /1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,
     2 1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ,1H ,1H0,1H1,
     3 1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H+,1H-,1H/,1H=,1H(,1H),1H*,1H,,
     4 1H.,1H$/
C
C
C     ------------------------------------------------------------------
C     THE IMPLEMENTOR MUST SUPPLY THE FOLLOWING TWO CARDS TO SUIT THE
C     INSTALLATION. NWORD=BITS/WORD,NCHAR=BITS/CHARACTER
C++JS++13FEB83++      DATA ISPEC /1H<,1H>,1H",1H',1H&,1H^,1H%,1H?,1H!,1H;,1H:/
C      DATA ISPEC /'x','y','u','l','c','g','s','b','i','d','t'/
      DATA ISPEC /14,15,16,17,18,19,20,21,22,23,24,25,26/
C      DATA ISPEC /0,0,0,0,0,0,0,0,0,0,0/
      DATA NWORD /32/, NCHAR /8/, IOUT /6/
ccray      DATA NWORD /64/, NCHAR /8/, IOUT /6/
C
C     ------------------------------------------------------------------
C
      DATA FIRST /.TRUE./ ,LNGTH /.FALSE./
      DATA ISY110 /471149226,357246358,315959338,336592896,470820906,
     2 345320100,357443862,327886236,315762474,336920576,470820906,
     3 355313115,336920576,470493226,449850016,0,455911911,456370649,0,
     4 471149216,336274848,336930848,0,470493226,357574048,336920576,
     5 449522346,315959958,0,470820906,355641947,336274907,317892650,0,
     6 456370208,336279584,351502336,481470811,325953253,347256234,
     7 326284694,325958294,346929184,357892096,449850016,470493226,
     8 455911911,485271143,0,450177706,315304598,315949056,470493226,0,
     9 470820906,355313115,336935525,336274917,355631104,470853600/
      DATA ISY111 /336570464,336625664,468592477,328181537,330409956,
     2 338831587,345024799,342796380,334364672,466265814,319563163,
     3 313468258,315794984,326444971,341158250,353643173,359738078,
     4 357411352,346761365,332038144,465905227,312910991,300491605,
     5 292332190,290530023,297116654,307799411,322611126,341518837,
     6 360295345,372714731,380874146,382676313,376089682,365406925,
     7 350595210,331677696,468592477,328181537,330409956,338831587,
     8 345024799,342796380,334378847,330344289,466560930,468625379,
     9 470722595,472819811,474949794,477079777,0,462300964,345123100,
     * 328087389,330413981,332511197,334608413,336705629,338802845/
      DATA ISY112 /340900061,342982656,470623971,347187226,464594973,
     2 342964256,334571552,338755584/
      DATA        JSTSYM      /1,5,11,14,17,20,24,27,30,35,38,45,50,53,
     2 55,60,63,70,81,98,113,123/
      DATA IAL110 /443556555,443557579,432612882,0,433070987,433071584,
     2 323987166,328083226,325854871,317404054,317400725,325723922,
     3 327657165,323364299,298156032,462268125,321889760,309339231,
     4 300852123,296493907,298329038,304489675,317040204,325527312,0,
     5 433070987,433071456,319792797,325953304,327788240,323429900,
     6 312845195,0,433070987,433071840,432743830,432383691,0,433070987,
     7 433071840,432743830,0,462268125,321889760,309339231,300852123,
     8 296493907,298329038,304489675,317040204,325527312,327792083,
     9 327778304,433070987,462432011,432744214,0,433070987,0,449848720/
      DATA IAL111 /312911116,306553867,298197837,294134546,0,433070987,
     2 462431122,443262731,0,433070987,432383627,0,433070987,433071499,
     3 466625931,466626443,0,433070987,433071883,462432011,0,443556959,
     4 300852123,296493907,298329038,304489675,317040204,325527312,
     5 329885528,328050397,321889760,309329920,433070987,433071584,
     6 323987166,328083225,325822102,317367189,0,443556959,300852123,
     7 296493907,298329038,304489675,317040204,325527312,329885528,
     8 328050397,321889760,309343631,327450624,433070987,433071584,
     9 323987166,328083226,325854871,317399958,447424267,0,460236383/
      DATA IAL112 /315630752,300917597,296592281,300688471,317367892,
     2 323593937,325527116,314942603,300294990,0,441459851,426780256,0,
     3 433070993,300360780,310748555,321267406,327722784,0,426779851,
     4 460334283,0,428876875,449848395,449849035,470820555,0,430974667,
     5 460333899,0,426779862,308655840,309002240,460333899,430974688,
     6 430286539,0,443556555,443557579,432612882,0,433070987,433071584,
     7 323987166,328083226,325854871,317404054,317400725,325723922,
     8 327657165,323364299,298156032,433070987,433071776,0,443556555,
     9 443557579,426092235,0,433070987/
      DATA IAL113 /433071840,432743830,432383691,0,460333899,430974688,
     2 430286539,0,433070987,462432011,432744214,0,443556959,300852123,
     3 296493907,298329038,304489675,317040204,325527312,329885528,
     4 328050397,321889760,309343382,319488000,433070987,0,433070987,
     5 462431122,443262731,0,443556555,443557579,0,433070987,433071499,
     6 466625931,466626443,0,433070987,433071883,462432011,0,428877472,
     7 436938134,428189323,0,443556959,300852123,296493907,298329038,
     8 304489675,317040204,325527312,329885528,328050397,321889760,
     9 309329920,433070987,462432011,433071904/
      DATA IAL114 /0,433070987,433071584,323987166,328083225,325822102,
     2 317367189,0,428877014,293974816,324023051,323321856,441459851,
     3 426780256,0,428712733,296723360,303047775,307143897,308655771,
     4 323921503,319825312,313500957,309100544,445654283,441295834,
     5 298623831,296362898,300459152,315106897,323561172,325822105,
     6 321725851,307068928,430974667,430286560,0,447751499,428680026,
     7 298623957,302621778,310945169,321463955,325756697,330114970,0,
     8 430285899,298394454,296559517,303015136,313533983,323921626,
     9 325789330,317040331,0,455910987,455812568,313304217,302785430,
     * 296330065/
      DATA IAL115 /298263564,306554187,317072974,0,433070987,432743448,
     2 307012953,317466198,323593873,321332684,312845451,302392206,0,
     3 455812568,313304217,302785430,296330065,298263564,306554187,
     4 317072974,0,456140363,455812568,313304217,302785430,296330065,
     5 298263564,306554187,317072974,0,430548563,321562135,317465945,
     6 307012632,298525523,296264590,302392459,312845772,321323008,
     7 445654176,303014876,300266265,309100544,455910985,318973381,
     8 312616068,302167638,317465945,307012632,298525523,296264590,
     9 302392459,312845772,321323008,433070987,432710744,309110169,
     * 319563349,321224704,430973855/
      DATA IAL116 /300950433,296760217,298156032,435168287,305144865,
     2 300954649,302261189,295838404,0,433070987,453813135,441034315,0,
     3 433070987,0,432841611,432710744,309110169,319563349,321238613,
     4 327952281,338471128,344631563,0,432841611,432710744,309110169,
     5 319563349,321224704,441230360,298525523,296264590,302392459,
     6 312845772,321332881,323593814,317465945,307003392,432841604,
     7 432743448,307012953,317466198,323593873,321332684,312845451,
     8 302392206,0,455910980,455812568,313304217,302785430,296330065,
     9 298263564,306554187,317072974,0,432841611,432645078,304882905,
     * 315392000/
      DATA IAL117 /453715416,311207001,298591062,298460179,313075153,
     2 319268366,317072651,304456588,296157184,435168207,302392459,
     3 310752025,309100544,432841615,300295243,310748556,321369689,
     4 321224704,428647563,453813387,0,430744651,447521867,447522379,
     5 464299595,0,430745099,453813067,0,428647563,453813387,302228357,
     6 293741252,0,453813067,430745113,430286347,0,443327576,300622740,
     7 296264526,298198027,306554124,317171282,325789465,443327833,
     8 315368918,321332876,325429003,0,449848607,307143705,300622738,
     9 296100612,449848864,323954331,321693208,315335895,443262294,
     * 317335058/
      DATA IAL118 /319268301,314975499,306553868,300327824,0,426451800,
     2 300721177,306980055,311043344,308655833,323692116,308651079,
     3 302120960,447521945,302785430,296330064,298230732,304456907,
     4 312878542,319333908,317433177,309175453,307209440,313533919,
     5 321814528,451650968,311207001,300688342,302654675,443130834,
     6 296231758,298198027,308651340,317128704,445654175,305079389,
     7 307111259,319665691,311206999,298459985,296199053,302359753,
     8 310617349,308421700,302186496,426418967,298624025,304882774,
     9 302588811,436806806,311174553,319596183,323626575,314703872,
     * 426418967,298624025,304882774,302556174,304489611,310748556/
      DATA IAL119 /319268433,323626713,325985951,319825312,313468252,
     2 315401750,323626834,0,437035922,296166220,298165259,306619599,0,
     3 437035787,457975385,319595928,306848787,300528595,304686225,
     4 310781259,314942924,0,426779488,300917790,319141017,293961728,
     5 439132868,436904912,300328011,308651340,317138514,460105298,
     6 319235596,321234635,329688975,0,430744601,300524430,296072857,
     7 321594900,315139278,302392139,0,445654175,305079389,307111259,
     8 319665499,307045401,300655573,304719122,315176210,302556048,
     9 296166220,300229832,310617349,306324484,0,441230360,298525523,
     * 296231821/
      DATA IAL120 /300295243,308651340,317138449,319432151,315368729,
     2 307003392,443327435,453813843,323430091,428549016,304916377,0,
     3 432645008,300327948,306554123,314975758,321431124,319530456,
     4 313304281,304882646,298427012,0,462202009,302785430,296330064,
     5 298230732,304456907,312878542,319333908,317433240,311197696,
     6 447521931,428549016,304916249,0,426418967,298624025,304882774,
     7 300426189,304456907,314975758,323561174,325877760,441197591,
     8 298492754,296199053,300295243,310748620,323430161,329918295,
     9 325887577,317433171,308749316,0,428647321,302753158,318908036,
     * 460105367,319431561,293806788/
      DATA IAL121 /0,458237060,426418967,298624025,304882774,302556174,
     2 304489675,312845836,323430161,332081113,0,441230360,298492754,
     3 296199052,300262475,308684111,449422671,314975691,321234636,
     4 329754514,332048216,327974912,445653835,445654731,445556363,
     5 434677265,426091595,451258187,0,435168203,437265419,428877344,
     6 326084382,330180442,327952087,319501856,323987166,328083226,
     7 325854871,319501334,319497941,327821138,329754381,325461515,
     8 293975574,323659476,327755535,325494412,319127552,460236570,
     9 328214237,321889696,311436383,300852123,296493907,298329038,
     * 304489739,314943052,325527312,445654175/
      DATA IAL122 /302949339,298591123,300426254,306586891,0,435168203,
     2 437265419,428877216,321890013,328050520,329885456,325527116,
     3 314942219,449848863,323921627,327952147,325592718,319169931,0,
     4 435168203,437265419,449652114,428877600,328017632,436938134,
     5 428189451,327722699,0,435168203,437265419,449652114,428877600,
     6 328017632,436938134,428188875,0,460236570,328214237,321889696,
     7 311436383,300852123,296493907,298329038,304489739,314943052,
     8 325530912,307209245,300786584,298427344,302457996,310752979,
     9 325433107,327530003,334069760,435168203,437265419,462432011,
     * 464529227,428877024,456140832/
      DATA IAL123 /436938518,428188875,455452683,0,435168203,437265419,
     2 428877024,428188875,0,445654287,308683851,300262220,294069008,
     3 296264592,296203488,308782220,304460832,317718528,435168203,
     4 437265419,464528403,447457099,445359883,428877024,456140768,
     5 428188875,455452619,0,435168203,437265419,428877024,428189387,
     6 325625483,0,435168203,437265806,435168651,464528779,464529227,
     7 466626443,428876832,464529504,428188811,457549899,0,435168203,
     8 437266189,437200651,462432011,428876832,456140768,428188811,0,
     9 445654111,300852123,296461140,298329038,304489739,314943052,
     * 325527312/
      DATA IAL124 /329918295,328050397,321889696,311440672,307209245,
     2 300786583,298460112,302457996,310752651,319170190,325592852,
     3 327919323,323921439,315621376,435168203,437265419,428877344,
     4 326084382,330180441,327919318,319464469,454043295,326051612,
     5 327984855,323692053,428188875,0,445654111,300852123,296461140,
     6 298329038,304489739,314943052,325527312,329918295,328050397,
     7 321889696,311440672,307209245,300786583,298460112,302457996,
     8 310752651,319170190,325592852,327919323,323921439,315634765,
     9 304555152,310945105,317203982,321103494,327362376,329561614,
     * 321201800,325297927,329515008,435168203,437265419,428877344/
      DATA IAL125 /326084382,330180442,327952087,319497238,454043295,
     2 326051612,328017624,323724822,428188875,447423957,319432397,
     3 327558988,331789781,319399564,325429067,331786126,0,458139360,
     4 325920413,319792480,307241951,296657755,298623960,304850389,
     5 321529554,430810073,304883158,321562260,325658318,321267083,
     6 308651020,298263377,296067982,0,443557067,445654283,430973722,
     7 294659808,325920416,436577739,0,435168209,302457996,312845771,
     8 323364622,329820000,437265425,304555212,312849184,309343904,
     9 336592896,430974219,433071374,460334347,426779744,451946336,0,
     * 433071243,435168400,449848459/
      DATA IAL126 /449848971,451946128,466626187,426779808,460335200,0,
     2 430974603,433071819,460333899,426779744,451946336,426091595,
     3 451258187,0,430974229,310752160,313173323,462431573,426779744,
     4 454043552,438674955,0,458236747,460333963,433070938,296756960,
     5 430286539,325625483,0,445653835,445654731,445556363,434677265,
     6 426091595,451258187,0,435168203,437265419,428877344,326084382,
     7 330180442,327952087,319501856,323987166,328083226,325854871,
     8 319501334,319497941,327821138,329754381,325461515,293975574,
     9 323659476,327755535,325494412,319127552,435168203,437265419,
     * 428877536,325920416/
      DATA IAL127 /428188875,0,445653771,445654795,445556427,430319308,
     2 428189451,0,435168203,437265419,449652114,428877600,328017632,
     3 436938134,428189451,327722699,0,458236747,460333963,433070938,
     4 296756960,430286539,325625483,0,435168203,437265419,462432011,
     5 464529227,428877024,456140832,436938518,428188875,455452683,0,
     6 445654111,300852123,296461140,298329038,304489739,314943052,
     7 325527312,329918295,328050397,321889696,311440672,307209245,
     8 300786583,298460112,302457996,310752651,319170190,325592852,
     9 327919323,323921439,315634841,306787865,319370390,319501461,
     * 319455232,435168203/
      DATA IAL128 /437265419,428877024,428188875,0,435168203,437265419,
     2 464528403,447457099,445359883,428877024,456140768,428188875,
     3 455452619,0,445653835,445654731,445556363,426091595,451258187,0,
     4 435168203,437265806,435168651,464528779,464529227,466626443,
     5 428876832,464529504,428188811,457549899,0,435168203,437266189,
     6 437200651,462432011,428876832,456140768,428188811,0,433103708,
     7 464561948,441197651,455878163,432513866,463972106,433039135,
     8 433006366,441132566,441099797,432449293,432416524,0,445654111,
     9 300852123,296461140,298329038,304489739,314943052,325527312,
     * 329918295/
      DATA IAL129 /328050397,321889696,311440672,307209245,300786583,
     2 298460112,302457996,310752651,319170190,325592852,327919323,
     3 323921439,315621376,435168203,437265419,462432011,464529227,
     4 428877856,428188875,455452683,0,435168203,437265419,428877344,
     5 326084382,330180441,327919318,319464469,454043295,326051612,
     6 327984855,323692053,428188875,0,430974230,293974816,309015328,
     7 326117146,324023116,323367691,325429009,323321856,443557067,
     8 445654283,430973722,294659808,325920416,436577739,0,428712733,
     9 296723360,303047775,307143897,308654877,298820639,307148507,
     * 326018719,321922528,315598173,311207179/
      DATA IAL130 /460236383,317695325,436577739,0,445654283,447751499,
     2 441295834,298623831,296362898,300459152,317204113,325658388,
     3 327919321,323823067,307082395,302851033,298558356,300491793,
     4 306722256,321431186,325723863,323790426,317568096,319829067,
     5 319127552,430974603,433071819,460333899,426779744,451946336,
     6 426091595,451258187,0,447751499,449848715,428647258,300721173,
     7 304718994,310948698,298623957,302621778,310945233,323561171,
     8 327853913,332215761,321463955,325756697,332212185,441460320,
     9 440772171,0,430384011,306553871,298427222,296559517,303015136,
     * 317728415,328116058,329983763,323462667/
      DATA IAL131 /327526222,436708306,298525594,300852319,309343712,
     2 321890013,328017686,325658255,432415820,455485196,0,434873302,
     3 298525591,300688473,313304536,319530581,321332876,325432855,
     4 319235660,325429003,453682644,304718738,296231758,298198091,
     5 310748556,319239251,300491664,298263500,304447488,435168203,
     6 437265419,436937880,311207321,321660630,327788305,325527116,
     7 314942731,306586638,449619480,323692243,325625486,319169931,
     8 428876832,0,455812629,321529493,323692056,315401433,302785430,
     9 296330065,298263564,308651339,319170190,443327576,300622739,
     * 298361806,304489675,0,456140363,458237579/
      DATA IAL132 /455812568,313304281,302785430,296330065,298263564,
     2 308651339,317072974,443327576,300622739,298361806,304489675,
     3 449848992,455452491,0,432645779,323659351,319563161,309109784,
     4 298525523,296264590,302392523,312845836,323434067,321594904,
     5 443327576,300622739,298361806,304489675,0,445621470,311338334,
     6 313500960,307242015,300852171,441459807,302949387,428647705,
     7 428188875,0,441230360,300655509,298427345,302523535,310879632,
     8 317236755,319464919,315368729,307016728,300622802,302527888,
     9 317269462,315373015,319563417,323757592,434676624,296166221,
     * 298165322,314910281,323236685,298198091/
      DATA IAL133 /314943050,323233415,321037700,302129989,293839624,
     2 296035339,0,435168203,437265419,436937880,313304537,323757782,
     3 325432793,321660566,323334944,303051531,308655563,331710464,
     4 435168159,300885023,300954585,300266521,302363417,302822155,
     5 308641792,437265375,302982239,303051865,304325637,297935620,
     6 291676870,293839686,293778457,302228421,297939801,304906240,
     7 435168203,437265419,458007567,447325899,445228683,428876832,
     8 451716953,428188875,451258187,0,435168203,437265419,428876832,
     9 428188875,0,434938827,437036043,436937880,313304537,323757782,
     * 325432793,321660566,323335894,330049561/
      DATA IAL134 /340568408,348858763,474786072,346761547,428647449,
     2 428188875,451258251,474327627,0,434938827,437036043,436937880,
     3 313304537,323757782,325432793,321660566,323334937,302822155,
     4 308655563,331710464,443327512,298525523,296264590,302392523,
     5 312845836,323430097,325691030,319563097,309114073,304882646,
     6 298427281,300360780,308655435,317072974,323528339,321594840,
     7 313294848,434938820,437036036,436937880,311207321,321660630,
     8 327788305,325527116,314942731,306586638,449619480,323692243,
     9 325625486,319169931,428647449,427959492,0,455910980,458008196,
     * 455812568,313304281,302785430,296330065,298263564/
      DATA IAL135 /308651339,317072974,443327576,300622739,298361806,
     2 304489675,448931652,0,434938827,437036043,436839510,309077337,
     3 319596120,321627670,317433368,428647449,428188875,0,451651097,
     4 319464919,315368729,302818200,296461141,298460179,313042384,
     5 319271766,298492948,313075153,319301133,317072715,304456652,
     6 298230607,296067981,0,435168207,302392459,310748556,317142048,
     7 302490700,306557721,311197696,434938830,302392523,312845836,
     8 323433497,302457932,308655769,323335897,325432089,302822873,
     9 325891723,331710464,430744779,432841933,455910603,426550361,
     * 447522521,0,432841867,434939022/
      DATA IAL136 /449619083,449619595,451716750,466396811,426550425,
     2 460105817,0,432842315,434939531,458007435,428647577,449619737,
     3 428188811,449160971,0,432841995,434939149,458007819,306422789,
     4 297935684,293774150,297972505,307017113,327974912,453813067,
     5 455910283,432841557,296527449,430286411,321365515,0,445424728,
     6 300622740,296264526,298198091,308651340,319268498,327886681,
     7 445424792,302719956,298361742,300295243,445425049,319563350,
     8 325527308,329627033,317466134,323430092,329623435,0,451945759,
     9 307143705,300622738,296100612,451945823,309240921,302719954,
     * 298197828,451946080,326084382/
      DATA IAL137 /328050393,323757527,309048928,326051547,323790424,
     2 317437143,317400660,323561103,321299980,312845515,304489485,
     3 300430551,315303444,321463887,319202764,312836096,426451800,
     4 300721241,309077271,313140560,310780996,428581784,306980119,
     5 462202582,323626317,306455556,460105366,321529165,0,451683673,
     6 309109784,298492754,296199053,300295243,308651404,319268434,
     7 321562135,311305438,309339425,315663904,323957977,304882645,
     8 298394510,300299467,312878543,319366678,317465947,311338271,
     9 313533920,323944448,455812568,313304153,300688342,304751891,
     * 439133208,302720148,311014675,300491600,296166284,304456971/
      DATA IAL138 /314975758,445228050,298328974,300295243,0,447751391,
     2 307176605,309208475,325953244,319661337,304849812,296264527,
     3 298230859,310682951,312648964,306324549,449651863,300557201,
     4 298296269,304447488,426418967,298624089,306979990,304686027,
     5 437036120,304817170,298169426,309011800,317498969,325854999,
     6 327821007,318912089,325822164,323462596,0,426418967,298624089,
     7 306979990,304653390,306586827,437036120,304817169,302457932,
     8 308651339,317072974,325625620,330082141,328181408,319825310,
     9 315499993,321595092,331953612,321365649,325723929,328115935,
     * 324009984,437035922,296166220,298165323,308716815/
      DATA IAL139 /439133138,298263436,300253184,437035787,439133003,
     2 458008280,327952089,321693144,308946003,300528723,308880716,
     3 314946643,306783500,312845771,321267407,0,430973920,305112222,
     4 309208654,323364555,435168350,307111438,321267403,327529753,
     5 293975321,296058880,439132868,441230084,439034896,302425227,
     6 310748556,319235729,462202446,321267339,329623501,336050009,
     7 323430028,325419008,437035915,439133203,300360587,460105365,
     8 319338265,325789332,319333775,308716620,298169177,304906240,
     9 447751391,307176605,309208475,321762715,307045401,300655573,
     * 304719122,317273499,309142617,302752789,306816274,445195281/
      DATA IAL140 /298328910,296100810,310650183,312648900,304231698,
     2 304653264,298263436,302327048,0,443327512,298492754,296199053,
     3 300295243,308651404,319268434,321562135,317465945,309114073,
     4 304882645,298394510,300299467,312878543,319366678,317456384,
     5 443294667,443294731,455878219,455878283,428549016,304916377,
     6 428549015,304883608,0,432546765,302392459,310748620,321365650,
     7 323659351,319563161,311207000,300589970,289551627,314975759,
     8 321463894,319567129,306979861,300491460,0,464299225,302785429,
     9 296297295,298230732,304456907,314975759,321463893,319530456,
     * 313308377,304882645,298394510,300299467/
      DATA IAL141 /312878543,319366678,317470168,330039296,447489163,
     2 447489227,428549016,304916249,428549015,304883480,0,426418967,
     3 298624089,306979990,302523405,306557977,304882774,300426189,
     4 302392459,308651404,319235729,325723863,323790424,323725012,
     5 457746135,0,441197591,298492754,296199053,300295243,310748620,
     6 323430161,329918295,325887577,317433171,308749316,430416845,
     7 304489740,317105807,327726935,325854808,317400403,308716612,0,
     8 428647321,302785622,314811845,318911385,300688406,312714629,
     9 318908036,460105367,319431561,293806788,0,456139972,458237060,
     * 426418967,298624089,306979990/
      DATA IAL142 /304653390,308684172,319203024,329888793,304882774,
     2 302556174,304489675,314942988,323430161,329885657,0,432710679,
     3 309077145,302785429,296297295,298197963,304456908,312976786,
     4 430416781,300295244,308716879,447292751,314975691,321234636,
     5 329754514,332048216,327984856,330016661,447194509,317072972,
     6 325494607,0,451945099,451945995,449783243,432580049,419799947,
     7 444966539,0,443556683,445653899,437266144,332376029,334342040,
     8 330016406,460334943,332310427,330049303,323695702,323692309,
     9 329885521,327624332,314942091,457909973,327788305,325527116,
     * 314933248,462366558,332408666,330180382/
      DATA IAL143 /326084192,315630815,305046490,298558291,296231821,
     2 300295307,312845772,321332880,449848607,307143706,300655507,
     3 298329037,302392459,0,443556683,445653899,437266016,328181598,
     4 332244887,329885391,321299916,308650635,456140511,328148827,
     5 330016531,323462669,314975435,0,443556683,445653899,453846418,
     6 437266400,332212128,439035350,423994955,325592587,0,443556683,
     7 445653899,453846418,437266400,332212128,439035350,423994443,0,
     8 462366558,332408666,330180382,326084192,315630815,305046490,
     9 298558291,296231821,300295307,310748620,321332946,449848607,
     * 307143706,300655507,298329037/
      DATA IAL144 /302392459,444966284,319235730,451487634,0,443556683,
     2 445653899,470820491,472917707,437265888,464529696,439035734,
     3 423994443,451258251,0,443556683,445653899,437265888,423994443,0,
     4 456140047,308716684,302359435,294003406,292037393,296231695,
     5 454042831,306619403,447751968,0,443556683,445653899,472917011,
     6 451651275,449554059,437265888,464529632,423994443,451258187,0,
     7 443556683,445653899,437265888,423994955,325625355,0,443556683,
     8 443557131,445654349,472917259,472917707,475014923,437265696,
     9 472918368,423994379,453355467,0,443556683,443557518,443459211/
      DATA IAL145 /470820491,437265632,464529632,423994379,0,449848543,
     2 305046490,298558291,296231821,300295243,310748620,321332945,
     3 327821144,330147614,326084192,315635104,311403677,302851031,
     4 298427280,300328011,444966284,319235729,325723928,328050398,
     5 321912832,443556683,445653899,437266208,334473245,336439256,
     6 329983573,304789280,332376029,334342040,327886421,423994443,0,
     7 449848543,305046490,298558291,296231821,300295243,310748620,
     8 321332945,327821144,330147614,326084192,315635104,311403677,
     9 302851031,298427280,300328011,444966284,319235729,325723928,
     * 328050398,321926093,300360720,306750673,313009550/
      DATA IAL146 /314811846,321070728,323270030,316941831,321103496,0,
     2 443556683,445653899,437266144,332376029,334342040,330016406,
     3 304821984,330278813,332244824,327919254,449521173,321529484,
     4 325429067,331786126,455747277,327558988,331788939,304447488,
     5 464463774,334505882,332277598,328181344,313533599,302949403,
     6 304915608,321529554,437101721,321562260,325658319,323397196,
     7 314942603,300295053,296198993,293970765,298221568,451945547,
     8 454042763,439362458,303048672,332212128,432383307,0,441459669,
     9 298361742,300295307,314943052,325527313,336606432,302687185,
     * 300360716,306557920,315635552,342884352,437265483/
      DATA IAL147 /439362701,466625611,433071392,458237984,0,441459723,
     2 443556941,458236939,458237451,460334669,475014667,435168672,
     3 468724064,0,439363083,441460299,468722379,435168608,460335200,
     4 421897163,447063755,0,437265686,304460896,313205899,468723030,
     5 433071392,460335200,432383307,0,466625227,468722443,441459674,
     6 305145824,426092107,325625355,0,466527124,331710464,432973716,
     7 298156032,455747095,317465945,309109784,298492754,296199053,
     8 300295243,308651404,319235665,323692187,321857055,315630816,
     9 305112094,302949469,305083609,304882645,298394510,300299467,
     * 312878542,319333974/
      DATA IAL148 /321758750,315621376,428877067,430974221,462431499,
     2 428877600,430941919,0,453780889,309109784,298525523,296231821,
     3 300295307,312845772,443327576,300622739,298329037,302392459,
     4 432612754,0,466625433,331953040,331887499,331710464,433072025,
     5 298398608,331887499,331710464,468166479,325592658,315303255,
     6 309077080,300655509,298427345,304620752,313042322,321595096,
     7 330082265,0,468821922,334538786,336701412,330442467,321955359,
     8 317597080,310781128,306394786,321922588,315106636,310682823,
     9 304260036,295838469,293806919,298001221,0,468821922,334538786,
     * 336701412,330442467,321955359/
      DATA IAL149 /317597080,310781128,306394786,321922588,315106636,
     2 310682823,304260036,295838469,293806919,298001221,447587482,
     3 302785493,300524560,306652493,317105806,327690067,329951000,
     4 323823067,313360384,470394833,329787088,321431058,313206039,
     5 306979864,298558293,296330129,302523536,310945106,319497815,
     6 325855064,334211093,336166912,449717643,432678804,432383883,0,
     7 449717643,432940956,432678804,0,432908045,462267277,0,451847580,
     8 317564444,317633428,336213453,314975691,319169997,0,439493700,
     9 441590916,479340804,481438020,431106660,430056836,469903940,0,
     * 434807700,300524564/
      DATA IAL150 /300580864,430744665,317109273,317044772,317030400,
     2 435299926,297939876,319501156,319468388,345123229,343028677,
     3 344109956,344074635,341966848,447751327,302916570,298558290,
     4 296166284,302359691,312878543,319333972,323790493,321889760,
     5 313537888,309306460,302851031,298394510,300295179,440771852,
     6 315074001,319432281,321824287,317731798,319488000,443688035,
     7 303113184,300885020,304981145,306947093,439460897,303015005,
     8 307111130,309077142,298460306,308815054,306586699,302294023,
     9 304264211,306750607,304522252,300229576,302195781,308412416,
     * 435299427,307307744,309273756,304981017,302752917,439461025,
     1 307209309/
      DATA IAL151 /302916570,300688406,311043090,300426190,302392395,
     2 306488455,304264339,302556175,304522380,308618440,306390085,
     3 300023808,462169818,321758619,311239897,306914451,308847952,
     4 319301265,325694875,311207126,308913425,313014043,325691089,
     5 329787344,338241685,340502618,336471966,328181344,315630815,
     6 305079260,298656599,296362897,300393549,308684171,321234700,
     7 331786190,464365331,327722832,0,434938776,296428372,298361997,
     8 308654932,298394766,308651209,306390020,300032901,295936842,
     9 298263570,306881880,317498969,327952214,329852686,323364363,
     * 317040012,315041231,319235533,455911128,327886610,325527180/
      DATA IAL152 /0,458008082,317138380,319137483,329688975,460105298,
     2 319235596,321238546,319464920,313304281,302785429,296297295,
     3 298230732,304456907,312878543,319370457,304882645,298394510,
     4 300285952,441459603,298329037,302396640,300528595,302720152,
     5 311207321,319563351,323659410,321365452,310748299,302392271,
     6 300529176,321594962,319268236,310752224,309329920,453715477,
     7 321562198,319563161,309109784,298492754,296199053,300295243,
     8 308651404,319272153,304882645,298394510,300285952,462431762,
     9 317138380,319137483,329688975,464528978,319235596,321238546,
     * 319464920,313304281,302785429,296297295,298230732,304456907/
      DATA IAL153 /312878543,319370457,304882645,298394510,300299872,
     2 330301440,432546961,313075220,321594904,315401433,302785429,
     3 296297295,298230732,304456907,314975758,443327576,300589970,
     4 298263500,0,456107550,321824414,323987040,317728095,311370972,
     5 307012555,298033989,451945822,311305432,304587787,300163974,
     6 295871172,287449605,285418055,289612357,432842265,0,460105163,
     7 314844421,304227204,293774022,291742472,295936774,458007947,
     8 312747205,304231954,319464920,313304281,302785429,296297295,
     9 298230732,304456907,312878543,319370457,304882645,298394510,
     * 300285952,441459467,443556683,434709590,309077337/
      DATA IAL154 /317498968,323724949,319268364,321238489,321627733,
     2 317171148,319137483,329688975,435168480,0,443557023,309273887,
     3 309342933,294364057,304915608,306881551,302392395,437036120,
     4 304784335,300295179,308651341,315064320,445654239,311371103,
     5 311440149,296461273,307012824,308978699,300163974,295871172,
     6 287449605,285418055,289612357,439133336,306881483,298066758,
     7 291635200,441459467,443556683,457975383,323692247,325854873,
     8 321693144,308946003,300528723,308880716,314946643,306783500,
     9 312845771,321267407,435168480,0,441459602,296166220,298165323,
     * 308716815,443556818,298263436,300266464,309329920/
      DATA IAL155 /426418967,298624089,306979990,304686027,437036120,
     2 304817170,298169426,309011800,317498969,325854999,327853643,
     3 455911127,325756427,459876182,334243929,342665560,348891541,
     4 344434956,346405081,346794325,342337740,344304075,354855567,0,
     5 426418967,298624089,306979990,304686027,437036120,304817170,
     6 298169426,309011800,317498969,325854999,327853711,323364555,
     7 455911127,325756495,321267339,329623501,336035840,443327512,
     8 298492754,296199053,300295243,308651404,319268434,321562135,
     9 317465945,309114073,304882645,298394510,300299467,312878543,
     * 319366678,317456384,426418967,298624089,306979990,304685892/
      DATA IAL156 /437036120,304817170,293745746,306881816,315401753,
     2 323757783,327853842,325559884,314942731,306586703,304690840,
     3 325789394,323462668,314946116,302120960,458007812,460105028,
     4 453584405,317465945,309109784,298492754,296199053,300295243,
     5 308651340,317171218,443327576,300589970,298263500,438445572,0,
     6 426418967,298624089,306979990,304686027,437036120,304817170,
     7 298169426,309011800,317498969,323757719,321594903,321650688,
     8 453748246,321594967,319563097,307012568,298558357,300557712,
     9 317174678,300590481,317203917,314975435,302359372,294036238,
     * 296166221,0,443556818,298263436,300262539,310814031/
      DATA IAL157 /445654034,300360652,302363481,315392000,426418967,
     2 298624089,306979989,302490637,306557977,304882773,300393421,
     3 302392459,310748556,319235730,462202514,321332812,323331915,
     4 333883407,464299730,323430028,325419008,426418967,298624089,
     5 306979989,302490637,306557977,304882773,300393421,302392459,
     6 308651404,319235729,325756633,323790551,0,426418967,298624089,
     7 306979989,302490637,306557977,304882773,300393421,302392459,
     8 310748556,319235664,460105296,321300108,327526283,335947918,
     9 342370580,344762585,344700697,323495565,327516160,430613464,
     * 304915737,313238868,443327767,311043280,306652172,298165067/
      DATA IAL158 /294003469,296166285,296105168,308716811,317040204,
     2 325564120,323725014,327919384,325887641,319563158,313140496,
     3 310814027,0,426418967,298624089,306979989,302490637,306557977,
     4 304882773,300393421,302392459,310748556,319235730,464299595,
     5 319038853,308421636,297968454,295936904,300131206,462202379,
     6 316941637,308412416,460105367,319464463,298230603,432710615,
     7 304915737,319534039,304882968,319530647,432448525,310781388,
     8 321303565,310748619,321300111,0,433202052,435299268,433202532,
     9 432153924,0,443688132,445785348,431105316,430056708,0,447751044,
     * 460334340,432711445,430417615/
      DATA IAL159 /0,447653148,313370012,315532639,309339232,300917661,
     2 298689497,304850324,434939158,315237842,317203854,310785048,
     3 298525524,296297360,302458187,432547021,312845705,314811717,
     4 308421700,300065671,298066889,302261191,0,441459806,307111134,
     5 307246240,306328725,304686212,308880533,428647320,302818202,
     6 294433561,319599897,315368985,315434265,0,434938776,300655640,
     7 300725197,298197963,302392269,0,434938776,300655640,300725195,
     8 298197965,302392330,300163975,0,435168158,300491806,300954590,
     9 300692429,298197963,302392269,0,432939995,298656603,296625054,
     * 300917856/
      DATA IAL160 /311436767,319759964,321725976,317433045,308884768,
     2 315598302,319694362,317465942,442934412,308651276,308707328,
     3 468722507,441459998,311305434,304915417,296592221,298820640,
     4 307242271,317662878,330278880,459875921,319268365,323331851,
     5 331753422,333981522,325648384,468461463,334178327,336340953,
     6 332179288,327886481,319235468,310748235,298197838,296264595,
     7 311141785,317564381,315598112,307209309,304981144,311076430,
     8 325461899,333817868,335983691,300295054,298361811,304788571,
     9 307013262,327559051,0,437035992,302752856,302822221,294003531,
     * 298188800,437035992,302752856,302822219,294003533,298197899/
      DATA IAL161 /296002247,0,441459807,300528799,300528800,309306323,
     2 430351116,296067980,296124416,439231643,304948251,302916702,
     3 307209568,321922847,330213211,327984856,313205973,308913426,
     4 315176544,326084381,328050393,323757591,440837196,306554060,
     5 306610176,430482259,298525719,306947350,319399570,327755667,
     6 334148435,298492950,306914581,319366801,327722898,334145495,0,
     7 445784916,310509568,433202516,297926656,433202052,0,430875547,
     8 323462861,325432218,323433309,296592281,323397323,441131922,
     9 296231758,298197835,430449612,432612240,300360652,296072531,
     * 323761693,319628888,325854938,321758749/
      DATA IAL162 /453944922,325844992,437265311,296657755,298624024,
     2 306980121,313369949,311403680,303038464,464201748,329856665,
     3 334112399,432678868,0,454042756,456139844,445424664,298525523,
     4 296231822,302392523,314943116,327624529,329918230,323757529,
     5 311211289,304882646,298427280,300360780,308655499,321267406,
     6 327722772,325789272,317489152,441459806,307111134,307246240,
     7 306787478,304751824,306652240,308946070,441001092,440673350,
     8 306324678,306459417,298591257,298656537,428647961,445425048,
     9 319595930,311210763,298132491,298197771,428189195,444966282,
     * 319137164,310738944,443556895,298722135,296362895,302392523/
      DATA IAL163 /312845836,323462868,325822108,319792480,309329920,
     2 437134493,313533771,0,432907164,300885023,307242400,319792734,
     3 323888794,321660373,296068811,0,435168928,311174616,321627798,
     4 325691089,323429900,312845451,300295053,296189952,451945298,
     5 327759328,317030400,456139744,298558424,307012953,319563414,
     6 325691089,323429900,312845451,300295053,296189952,458139231,
     7 315630880,305112028,298558354,300360780,310748491,319170190,
     8 325625554,323659287,313271576,304849877,298385408,460334155,
     9 430974688,0,441459679,298754971,300721240,313239062,323626706,
     * 325559949,321267083,306553804,298230607/
      DATA IAL164 /296297364,302720215,317466201,323856029,321889696,
     2 307232768,458008150,317334803,308913172,298525529,296559517,
     3 303015136,311436767,321824409,323626575,317072651,306553804,
     4 298254336,451847627,432678932,0,432678932,0,466756356,0,432777239
     5,432580625,0,447882466,305112027,298525586,300328009,308487492,0,
     6 431104994,305112283,311108882,308716617,300098372,0,441263246,
     7 430679505,451650385,0,436609995,298197965,302392330,300163975,0,
     8 434545548,300262412,300318720,441590919,449979783,460236383,
     9 315630752,300917597,296592281,300688471,317367892/
      DATA IAL165 /323593937,325527116,314942603,300294990,0,443556895,
     2 298722135,296362895,302392523,312845836,323462868,325822108,
     3 319792480,309343456,305112094,300819351,298460111,302425164,
     4 308655435,317072909,321365652,323724892,319759839,313524224,
     5 437134493,313533771,445621515,436577867,0,432939995,298656603,
     6 296625054,300917920,315631199,323954396,325920408,317400212,
     7 302621585,296166219,449848863,321857180,323823192,315303060,
     8 430351246,302458188,319170189,325530638,312845899,323364558,
     9 325582848,432939995,298656603,296625054,300917920,315631199,
     * 323921562,321660311,309048736,319792733,321725976/
      DATA IAL166 /315340183,319497876,325658319,323397196,314942603,
     2 300295053,296198992,298361808,298301013,323561103,321299980,
     3 314933248,449783179,451945931,451945233,327726283,323321856,
     4 435168086,430646232,307012953,319563414,325691089,323429900,
     5 312845451,300295053,296198992,298361808,298300761,317466198,
     6 323593873,321332684,312849376,321926111,311404128,0,456042012,
     7 321758876,323921503,317728032,305112029,298689367,296264590,
     8 302392523,312845836,323430097,325658261,319530328,311174231,
     9 300589970,445654175,302949339,298558353,300360780,308655435,
     * 317072974,323528338,321562071,313262080,430973786,430842782/
      DATA IAL167 /303047840,317630045,323954400,433005599,307209693,
     2 460334813,323822997,313107728,310752922,313173267,308815051,0,
     3 441459679,298754970,300688535,315336280,323823261,321889696,
     4 307246240,303014877,300753944,306951575,319563354,321824287,
     5 315634839,300622741,296330063,298230732,306554251,321267341,
     6 325560019,323659350,315339927,302719957,298427279,300327948,
     7 306558347,319170125,323462803,321562134,315326464,458008150,
     8 317334803,308913172,298525529,296559517,303015136,313533983,
     9 323921626,325723792,321332684,310748235,300295054,298296272,
     * 302490574,443130964,300622745,298656733,305112288,447751647/
      DATA IAL168 /321824410,323626576,319235468,310738944,451847627,
     2 432678932,0,432678932,0,466756356,0,432777239,432580625,0,
     3 447882466,305112027,298525586,300328009,308487492,443622494,
     4 302883798,300491789,304424134,0,431104994,305112283,311108882,
     5 308716617,300098372,435233886,307078358,308880525,304423878,0,
     6 441459860,430876119,451846999,0,434480012,300327948,302326728,
     7 298024960,434545548,300262412,300318720,441590919,449979783,
     8 458139228,323856092,326018655,315630752,300917597,296592281,
     9 300688471,317367892,325661531,300721240,317400661,323626706,
     * 325527116/
      DATA IAL169 /314942603,300294990,296199056,300393358,0,449848543,
     2 305046490,298558291,296231821,300295243,308651404,319235729,
     3 325723928,328050398,323986976,315635104,311403677,302851031,
     4 298427280,300328011,442869068,317138513,323626712,325953182,
     5 319815680,449717323,454042763,454042973,307078170,451847387,
     6 302841856,439231643,304948251,302916702,307209568,319825631,
     7 328115995,325887575,315270291,300458831,291878432,323987165,
     8 325953177,319530131,428254030,300360972,317072973,323466190,
     9 310748619,321267343,0,439231643,304948251,302916702,307209568,
     * 319825631,328115995,325887511,313210400,323987165/
      DATA IAL170 /325953177,319534294,313206293,321529490,323462733,
     2 319169867,304456588,296133391,294134609,298328911,447423957,
     3 319432274,321365517,317072715,0,458204427,460334411,460333841,
     4 327712768,443556758,443557728,443524639,330314646,300655768,
     5 313271831,321595028,323528270,317072651,304456588,296133391,
     6 294134609,298328911,447489495,319497812,321431054,314975499,0,
     7 460236444,325953308,328115935,321922464,309306461,300753815,
     8 296330063,298230732,304456971,317072974,323495571,321562134,
     9 315335895,304817108,298399136,311403677,302851031,298427278,
     * 300299531,314975758,321398356,319488000,437265306/
      DATA IAL171 /464529181,323822932,308847759,304461466,311043217,
     2 304587787,435070112,311436893,437200031,311404125,326018846,
     3 330301440,447751327,305079324,302818391,309011862,323725016,
     4 328017693,326084128,313537888,309306526,305013849,306947286,
     5 449521239,323757786,326018719,319829206,300589907,294167310,
     6 296100875,310748684,321300111,323561044,319464854,443229205,
     7 298427217,296166284,302363915,317072909,321365587,319455232,
     8 460105367,319464852,308946005,302719960,300786717,307209568,
     9 319825567,326051612,327952084,323528206,314975435,302359436,
     * 296166223,298329039,298267733,302752795,305046751,313538207,
     1 326018776/
      DATA IAL172 /323626577,317138252,308641792,451847627,432678932,0,
     2 432678932,0,475144708,0,432777239,432580625,0,456271201,307176475
     3,298558290,296166281,300098564,447784093,302818262,298361740,
     4 300131332,0,443688226,313501082,315303249,308716618,298033796,
     5 443688225,313402711,310977743,304456583,0,445654292,435070551,
     6 456041431,0,430285580,296133516,298165065,291733504,430351116,
     7 296067980,296124416,449979271,460465351,462300891,328017755,
     8 330180382,326084128,311436383,300852187,302818392,319432338,
     9 435004505,319465044,323561103,321299980,312845387,298197837/
      DATA IAL173 /294101776,296264592,296189952,443556895,298722135,
     2 296362895,302392523,312845836,323462868,325822108,319792480,
     3 309343327,300819351,298460111,304493581,308684108,319206860,
     4 321365652,323724892,317699614,313500895,302972928,437134493,
     5 313533771,437134363,307111198,310748491,0,432907164,300885023,
     6 307242400,319792734,323888794,321660373,298169243,300786652,
     7 302982303,315598366,321791578,319563157,296072076,325461707,
     8 430286539,0,435168928,309048288,300918367,456139927,443295064,
     9 319530645,325658321,323429900,312845451,300295053,296199055,
     * 441165143,319497875,449554005,323561105,321332620/
      DATA IAL174 /457713165,312878220,300327823,438707086,0,451847627,
     2 319141408,319141408,296232720,451847056,432580369,327680000,
     3 435168151,437232600,435168864,321893407,321893336,307012953,
     4 319563414,325691089,323429900,312845451,300295053,296199055,
     5 432776151,304883032,319530644,449586774,323593873,321332620,
     6 457713165,312878220,300327823,438707086,0,454010461,323921503,
     7 315630880,305112028,298558354,300360780,310748491,319170190,
     8 325625554,323659287,313271576,304849877,456074655,311403614,
     9 441426972,300655570,302458060,434644045,310781260,319202960,
     * 449193550,323528338,321562007,457811478,313238807/
      DATA IAL175 /304817107,443261973,300482560,430974688,304460640,
     2 296724127,458236939,304447488,441459679,298754971,300721176,
     3 306947478,319465044,323561103,321299852,306586573,298296210,
     4 300557333,306914711,319563353,323856029,321889696,307246111,
     5 300852187,302818456,315336214,323626706,325559949,321267083,
     6 306553804,298230607,296297364,302720151,315368985,321758813,
     7 319796830,315597983,300888974,304494028,323420160,455812564,
     8 311010515,302654358,296526682,298755103,309339424,317695581,
     9 323790484,321365452,310748299,300295054,300360716,455910934,
     * 313144920,317367572,308945941,298595476,300622745,298656733,
     1 307213211/
      DATA IAL176 /302982367,311403998,321762655,319727193,321529359,
     2 314979789,310781068,300318720,449750412,317076893,317629900,
     3 432711637,334115733,298461140,0,432711637,334115733,298461140,0,
     4 466756356,295843748,334635844,0,432842713,334246809,298592216,
     5 432580561,333984657,298330064,0,445785250,303014811,296428370,
     6 298230793,306390276,312620324,313664738,305112027,298525586,
     7 300328009,308487492,0,431104994,305112283,311108882,308716617,
     8 300098372,297939812,298984482,307209499,313206098,310813833,
     9 302195588,0,441459807,308978836,441459860,441459935,304784532,
     * 430875549/
      DATA IAL177 /315336151,430876119,430875484,317466071,451847581,
     2 298558295,451846999,451847644,296493911,0,438707211,300262284,
     3 298230734,302457933,304423944,298038221,300295180,302425037,
     4 436577354,438707208,0,434578317,298197963,302359628,304522254,
     5 300364749,300295180,302425037,0,443688135,310621412,311567623,
     6 453944989,319792480,307241951,296657755,298623960,317335059,
     7 321431119,319202636,306586637,300365341,317662559,307209182,
     8 298754971,300721621,321496721,323462733,319169867,306553804,
     9 296166350,455550348,0,445653771,445555531,293975325,325429003,
     * 445654795,434677329,432547472/
      DATA IAL178 /0,433070987,435135436,433071520,321889950,325986009,
     2 323724886,315274207,315598430,323888793,321627542,434840982,
     3 321562260,325658319,323397196,314942347,434808213,321529490,
     4 323462733,314975180,0,462268125,321889760,309339231,300852123,
     5 296493907,298329038,304489675,317040204,325527312,462268123,
     6 323921502,317695199,305079259,298591123,300426317,308684236,
     7 321300110,325592848,0,433070987,435135436,433071456,319792797,
     8 325953304,327788240,323429900,312845195,435135839,319759965,
     9 323856088,325691024,321332749,312878028,0,433070987,435135436,
     * 433071776,435136159,324023254/
      DATA IAL179 /313206101,434808149,434513548,323335051,323321856,
     2 433070987,435135435,298169248,324023263,323987104,434840918,
     3 313177045,313163776,462268125,321889760,309339231,300852123,
     4 296493907,298329038,304489675,317040204,325527312,327820756,
     5 462268123,323921502,317695199,305079325,300786584,298427344,
     6 302457933,308684236,321300110,325592787,317302228,0,433070987,
     7 433071072,300262283,462431968,325429003,462432011,434841302,
     8 434808533,0,433070987,300266400,300950475,0,449848720,312911052,
     9 304489421,298328912,449848800,317203853,312878283,304456652,
     * 298230608,0,433070987,300266400/
      DATA IAL180 /300950475,462431968,300562208,300528791,325429003,
     2 443262731,0,433070987,433071072,300299212,323364491,432383627,0,
     3 433070987,435004363,298169307,314946464,315045792,315045723,
     4 314947419,329623435,466626443,0,433070987,435069899,298169309,
     5 327529376,325531360,325531360,328214283,0,443556959,300852123,
     6 296493907,298329038,304489675,317040204,325527312,329885528,
     7 328050397,321889760,309343519,305079259,298591123,300426317,
     8 310781324,321300176,327788312,325953118,315598111,0,433070987,
     9 435135435,298169248,317728351,323954396,325887639,321594837,
     * 300594143,317695582/
      DATA IAL181 /323888793,321627606,300613632,443556959,300852123,
     2 296493907,298329038,304489675,317040204,325527312,329885528,
     3 328050397,321889760,309343519,305079259,298591123,300426317,
     4 310781324,321300176,327788312,325953118,315598111,449259209,
     5 327464334,317138697,0,433070987,435135435,298169248,315631199,
     6 323954396,325887639,321594773,300594143,315598430,323888793,
     7 321627542,300627221,323331787,447391435,0,460236383,315630752,
     8 300917597,296592281,300688471,315270676,321496721,323429965,
     9 314975372,302425038,296171229,321824286,315597983,300884893,
     * 298689497,304883094,319465107,325625550,321267083/
      DATA IAL182 /306553804,296157184,441427083,443524299,306557728,
     2 321922655,428876575,321880064,433070993,300360780,310748555,
     3 321267406,327722784,433071072,300459022,304522508,314975821,
     4 323430097,326117152,0,428877067,428876640,310851360,326116622,
     5 462431499,0,428876939,428876640,306656736,306656733,306558429,
     6 327529952,327628960,338700046,475014923,0,430974603,325432160,
     7 298854091,460334752,296072928,298165067,0,428877014,308651275,
     8 428876640,311113440,324019414,460334358,310738944,458236747,
     9 460333963,430974688,430973791,323990412,325461707,430286539,0,
     * 455910987,323335769/
      DATA IAL183 /323790475,455812568,313304217,302785430,296330065,
     2 298263564,306554187,317072974,455812440,306979863,300622739,
     3 298361806,302425228,312878670,0,433070987,300266400,300950475,
     4 434840664,309110169,319563414,325691089,323429900,314942667,
     5 304489422,434840792,315368983,321595027,323528270,319202700,
     6 308683726,0,455812568,313304217,302785430,296330065,298263564,
     7 306554187,317072974,455812629,317433176,306979863,300622739,
     8 298361806,302425228,312878541,319268430,0,456140363,323335776,
     9 324019851,455812568,313304217,302785430,296330065,298263564,
     * 306554187,317072974,455812440,306979863/
      DATA IAL184 /300622739,298361806,302425228,312878670,0,432612946,
     2 321562135,317465945,307012632,298525523,296264590,302392459,
     3 312845772,321336211,319399445,317433176,306979863,300622739,
     4 298361806,302425228,312878541,319268430,0,447751392,305112092,
     5 302359627,447751519,309306462,441427036,304460633,311207192,
     6 430744408,311164928,458008153,321201671,316876101,308454470,
     7 302228359,458008202,321103301,312616068,302162823,455812568,
     8 313304217,302785430,296330065,298263564,306554187,317072974,
     9 455812440,306979863,300622739,298361806,302425228,312878670,0,
     * 433070987,300266400,300950475,434807960/
      DATA IAL185 /311207385,321660565,323335125,306947352,315368983,
     2 321562187,323321856,433070943,296690589,300852254,303014880,
     3 298857375,298787806,300917663,432841611,300266393,300721099,0,
     4 433070943,296690589,300852254,303014880,298857375,298787806,
     5 300917663,432841604,300037017,300721092,0,433070987,300266400,
     6 300950475,458008153,300398233,300364946,319137419,443131531,0,
     7 433070987,300266400,300950475,0,432841611,300266393,300721099,
     8 434807960,311207385,321660565,323335125,306947352,315368983,
     9 321562187,323335829,330049497,340568344,346728779,457877335,
     * 334243928,342599957,344303947/
      DATA IAL186 /0,432841611,300266393,300721099,434807960,311207385,
     2 321660565,323335125,306947352,315368983,321562187,323321856,
     3 441230360,298525523,296264590,302392459,312845772,321332881,
     4 323593814,317465945,307016856,302752726,298427281,300360717,
     5 306586956,317105678,321431123,319497687,313271448,0,432841604,
     6 300037017,300721092,434840664,309110169,319563414,325691089,
     7 323429900,314942667,304489422,434840792,315368983,321595027,
     8 323528270,319202700,308683726,0,455910980,323106393,323790468,
     9 455812568,313304217,302785430,296330065,298263564,306554187,
     * 317072974,455812440,306979863,300622739/
      DATA IAL187 /298361806,302425228,312878670,0,432841611,300266393,
     2 300721099,434742294,306980121,317502419,302687383,311174616,
     3 317489152,453715416,311207001,298591062,298460179,313042384,
     4 449357263,317138316,451323148,304489357,434512782,296171030,
     5 317400472,451650840,304882583,434906006,300561301,302654802,
     6 317236751,319235532,310748235,298197838,0,435168203,302363616,
     7 303047691,428647641,309080857,294397144,0,432841615,300295243,
     8 310748556,321368985,300721103,302425228,310781325,321369689,
     9 321234571,455911065,323321856,428647563,428647257,306624025,
     * 317498509,453813387,0,430744715/
      DATA IAL188 /430744473,306656665,306656662,306558358,323335577,
     2 323434457,332179086,468493963,0,430745099,321237849,298624587,
     3 455910937,296072793,298165067,0,428647563,428647257,306624025,
     4 317498509,297940505,306553796,297926656,451683147,455910348,
     5 430745177,430744408,317469644,321267275,430286411,0/
      DATA WID110 /18.,21.,21.,21.,19.,18.,21.,22.,8.,16.,21.,17.,24.,
     2 22.,22.,21.,22.,21.,20.,16.,22.,18.,24.,20.,18.,20.,18.,21.,17.,
     3 18.,19.,20.,22.,22.,8.,21.,18.,24.,22.,18.,22.,22.,21.,18.,16.,
     4 18.,20.,20.,22.,20.,19.,19.,18.,19.,18.,12.,19.,19.,8.,10.,17.,8.
     5,30.,19.,19.,19.,19.,13.,17.,12.,19.,16.,22.,17.,16.,17.,21.,19.,
     6 19.,18.,16.,15.,20.,21.,11.,18.,16.,21.,18.,16.,17.,22.,18.,20.,
     7 20.,20.,22.,18.,23.,23./
      DATA WID111 /20.,22.,21.,22.,21.,20.,23.,24.,11.,15.,22.,18.,25.,
     2 23.,22.,22.,22.,22.,20.,19.,24.,20.,24.,20.,21.,20.,20.,22.,18.,
     3 20.,21.,20.,24.,22.,11.,22.,20.,25.,23.,22.,22.,24.,22.,21.,19.,
     4 19.,21.,20.,23.,22.,20.,21.,19.,21.,19.,13.,19.,22.,11.,11.,21.,
     5 11.,33.,22.,20.,21.,20.,17.,17.,15.,22.,18.,24.,20.,19.,18.,23.,
     6 21.,20.,19.,18.,18.,22.,23.,12.,20.,20.,23.,20.,17.,18.,22.,19.,
     7 21.,20.,20.,22.,18.,23.,23./
      DATA WID112 /20.,24.,21.,23.,23.,22.,22.,26.,13.,18.,23.,20.,27.,
     2 25.,22.,23.,22.,24.,23.,21.,25.,20.,26.,22.,21.,22.,24.,24.,19.,
     3 20.,17.,24.,24.,25.,24.,24.,25.,24.,24.,22.,26.,34.,10.,22.,31.,
     4 19.,14.,14.,27.,22.,21.,19.,18.,21.,18.,15.,20.,21.,13.,13.,20.,
     5 12.,33.,23.,18.,21.,20.,17.,17.,14.,23.,20.,29.,20.,21.,20.,14.,
     6 14.,21.,16.,16.,10.,10.,10.,18.,24.,25.,11.,11.,11.,21.,24.,14.,
     7 14.,8.,20.,14.,26.,22.,16./
      DATA WID113 /20.,20.,20.,20.,20.,20.,20.,20.,20.,20.,26.,26.,22.,
     2 26.,14.,14.,16.,10.,10.,20.,20.,20.,20.,20.,20.,20.,20.,20.,20.,
     3 20.,26.,26.,22.,26.,14.,14.,16.,10.,10.,20.,21.,21.,21.,21.,21.,
     4 21.,21.,21.,21.,21.,26.,26.,22.,26.,15.,15.,17.,11.,11.,21.,20.,
     5 20.,20.,20.,20.,20.,20.,20.,20.,20.,25.,25.,23.,25.,14.,14.,16.,
     6 11.,11.,19.,20.,20.,21.,21.,19.,18.,21.,22.,9.,17.,21.,17.,24.,
     7 22.,22.,20.,22.,20.,20.,17./
      DATA WID114 /22.,20.,26.,20.,19.,20.,20.,20.,18.,20.,18.,14.,20.,
     2 20.,9.,9.,19.,9.,31.,20.,19.,20.,20.,14.,17.,11.,20.,16.,24.,18.,
     3 16.,18./
      DATA IST110 /1,5,16,26,34,39,43,54,58,60,66,70,73,78,82,93,100,112
     2,120,131,134,140,143,148,151,154,158,162,173,176,180,185,189,193,
     3 205,207,211,214,219,223,227,238,242,249,253,256,265,275,278,287,
     4 296,305,314,322,331,340,344,355,360,364,370,374,376,385,390,399,
     5 408,417,421,430,434,439,442,447,450,455,459,471,486,494,506,515,
     6 526,535,549,554,563,567,577,584,598,607,613,623,632,636,644,655,
     7 662,672/
      DATA IST111 /683,690,710,726,740,749,757,775,785,790,799,809,815,
     2 826,834,855,868,898,918,935,942,952,958,967,975,983,990,997,1017,
     3 1023,1029,1038,1045,1055,1080,1085,1095,1101,1112,1120,1133,1154,
     4 1162,1175,1183,1190,1205,1226,1234,1252,1272,1290,1305,1319,1335,
     5 1350,1360,1388,1399,1406,1417,1427,1432,1450,1461,1478,1494,1509,
     6 1519,1535,1542,1553,1559,1568,1576,1585,1592,1611,1637,1650,1671,
     7 1686,1701,1716,1737,1744,1757,1767,1779,1789,1810,1825,1834,1849,
     8 1865,1872,1887,1905,1916,1932/
      DATA IST112 /1953,1960,1978,1995,2009,2018,2026,2046,2056,2061,
     2 2071,2081,2087,2098,2106,2126,2138,2167,2185,2202,2209,2220,2226,
     3 2235,2243,2251,2258,2260,2262,2283,2289,2301,2305,2309,2320,2336,
     4 2360,2373,2377,2381,2384,2391,2399,2402,2406,2415,2435,2454,2473,
     5 2500,2522,2540,2556,2568,2587,2600,2617,2637,2651,2663,2678,2693,
     6 2701,2725,2742,2757,2776,2791,2803,2817,2825,2842,2855,2874,2894,
     7 2913,2927,2932,2937,2942,2964,2977,2983,2990,2997,3012,3027,3051,
     8 3056,3063,3070,3086,3098,3100,3102,3104,3123,3130,3135,3154/
      DATA IST113 /3177,3186,3189,3197,3205,3208,3217,3229,3232,3247,
     2 3259,3262,3264,3266,3269,3275,3281,3285,3290,3293,3306,3325,3330,
     3 3351,3373,3378,3396,3419,3433,3462,3485,3488,3490,3492,3495,3505,
     4 3515,3519,3523,3526,3546,3566,3572,3592,3616,3620,3638,3660,3673,
     5 3702,3724,3727,3729,3731,3734,3744,3754,3758,3762,3765,3784,3803,
     6 3809,3825,3846,3853,3876,3904,3909,3941,3969,3976,3980,3984,3991,
     7 4003,4015,4031,4042,4050,4074,4082,4102,4121,4136,4146,4154,4176,
     8 4185,4189,4199,4208,4214,4224,4232,4252,4264,4287,4302,4323/
      DATA IST114 /4329,4341,4347,4357,4364,4371,4379,4396,4413,4429,
     2 4446,4464,4474,4497,4508,4519,4530,4539,4543,4562,4573,4591,4608,
     3 4625,4634,4656,4663,4674,4680,4690,4697,4704/
C
      END
C
C ****************************************************************
C
C     *** INTERFACE TO HERSHEY CHARACTER GENERATOR
C
      SUBROUTINE CGXTYP(I)
      CHARACTER CCH(4)*1
      COMMON /HERSH/ ITYP,CCH
C
      IF (I.GE.1.AND.I.LE.4) ITYP=I
      RETURN
      END
C
C ****************************************************************
C
      SUBROUTINE CGXSMX(X,Y,H,TEXT,THETA,N)
      DIMENSION IDUMMY(21)
      CHARACTER TEXT(20)*4,BUF(22)*4
      CHARACTER CCH(4)*1
      COMMON /HERSH/ ITYP,CCH
      EQUIVALENCE (IDUMMY(1),BUF(1))
C
      IF (ITYP.LT.1.OR.ITYP.GT.4) ITYP=1
      IF (N.LT.0) THEN
           CALL CGXSMB(X,Y,H,TEXT,THETA,N)
      ELSE
           N4=(N-1)/4+1
           WRITE(BUF,200) CCH(ITYP),(TEXT(J),J=1,N4),':'
 200           FORMAT(A1,20A4,A1)
           CALL CGXSMB(X,Y,H,BUF,THETA,N+1)
           END IF
      RETURN
      END
C
C ****************************************************************
C
c      SUBROUTINE BLCKX6
      block data BLCKX6
      CHARACTER CCH(4)*1
      COMMON /HERSH/ ITYP,CCH
      DATA CCH /'%',' ','&','!'/
      END
C
C ****************************************************************
C
      SUBROUTINE CGXPIN(X,Y,H,NUMB,THETA,IW)
C     PLOTS AN INTEGER NUMBER EQUIVALENTLY TO THE
C     FORTRAN I - FORMAT.
C
      CHARACTER BUF(80)*4
      CHARACTER*1 FORMI(6),FORMF(10),FORME(10),FORMG(10)
      DATA FORMI / '(','I',' ',' ',')',' ' /
      DATA FORMF / '(','F',' ',' ','.',' ',' ',' ',')',' ' /
      DATA FORME / '(','E',' ',' ','.',' ',' ',' ',')',' ' /
      DATA FORMG / '(','G',' ',' ','.',' ',' ',' ',')',' ' /
C
 100  FORMAT(I2)
      WRITE(FORMI(3),100) IW
      WRITE(BUF,FORMI) NUMB
      GO TO 99
C
C ---------------------------------------------------
C
      ENTRY CGXPFN(X,Y,H,FNUMB,THETA,IW,ID)
C     PLOTS A FLOATING NUMBER EQUIVALENTLY TO THE
C     FORTRAN F - FORMAT.
C
      WRITE(FORMF(3),100) IW
      WRITE(FORMF(6),100) ID
      WRITE(BUF,FORMF) FNUMB
      GO TO 99
C
C ---------------------------------------------------
C
      ENTRY CGXPEN(X,Y,H,FNUMB,THETA,IW,ID)
C     PLOTS A FLOATING NUMBER EQUIVALENTLY TO THE
C     FORTRAN E - FORMAT.
C
      WRITE(FORME(3),100) IW
      WRITE(FORME(6),100) ID
      WRITE(BUF,FORME) FNUMB
      GO TO 99
C
C ---------------------------------------------------
C
      ENTRY CGXPGN(X,Y,H,FNUMB,THETA,IW,ID)
C     PLOTS A FLOATING NUMBER EQUIVALENTLY TO THE
C     FORTRAN G - FORMAT.
C
      WRITE(FORMG(3),100) IW
      WRITE(FORMG(6),100) ID
      WRITE(BUF,FORMG) FNUMB
 99   CALL CGXSMX(X,Y,H,BUF,THETA,IW)
      RETURN
      END
C
C ****************************************************************
C
      SUBROUTINE CGXNUM(X,Y,H,FNUMB,THETA,ID)
      IF (ID.GE.0) THEN
           ANUMB=FNUMB+SIGN(.5/10.**ID,FNUMB)
      ELSE
           ANUMB=FNUMB+SIGN(.5,FNUMB)
           END IF
      IW=IFIX(ALOG10(ABS(ANUMB)))+1
      IF (IW.LE.0) IW=1
      IF (ANUMB.LT.0) IW=IW+1
      IF (ID.GE.0) THEN
           IW=IW+ID+1
           CALL CGXPFN(X,Y,H,FNUMB,THETA,IW,ID)
      ELSE
           CALL CGXPIN(X,Y,H,IFIX(ANUMB),THETA,IW)
           END IF
      RETURN
      END
C
C ****************************************************************
C
      SUBROUTINE CGXPLT(X,Y,IVAL)
C     ***INTERFACE TO DISPLA
      IF (IVAL.EQ.2) THEN
           CALL BLXDRW(X,Y)
      ELSEIF (IVAL.EQ.3) THEN
           CALL BLXMOV(X,Y)
      ELSE
           STOP 'CGXPLT ERROR'
           ENDIF
      RETURN
      END
C
C ============================================
C
C/    INTEGER FUNCTION CHXCVT(IVAL)
CC/   ***JS FIDDLE ROUTINE FOR CHAR TO INT CONVERSION
C/    CHXCVT=IVAL
C/    RETURN
C/    END
